diff --git a/modules/NUCLEO-L476RG/module.h b/modules/NUCLEO-L476RG/module.h
index c38d503..cc370d1 100644
--- a/modules/NUCLEO-L476RG/module.h
+++ b/modules/NUCLEO-L476RG/module.h
@@ -28,7 +28,6 @@ along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #define AMIROOS_MODULE_H
 
 #include <amiroos.h>
-#include <math.h>
 
 /*===========================================================================*/
 /**
@@ -61,7 +60,7 @@ extern SerialConfig moduleHalProgIfConfig;
  */
 #define MODULE_HAL_RTC                          RTCD1
 
-#if defined(AMIROLLD_CFG_MPU6050)
+#if (BOARD_MPU6050_CONNECTED == true) || defined(__DOXYGEN__)
 
 /**
  * @brief   I2C driver to access multiplexer, proximity sensors 5 to 8, power monitors for VSYS4.2, VIO 5.0 and VDD, EEPROM, touch sensor, and fuel gauge (front battery).
@@ -73,7 +72,7 @@ extern SerialConfig moduleHalProgIfConfig;
  */
 extern I2CConfig moduleHalI2c3Config;
 
-#endif /* defined(AMIROLLD_CFG_MPU6050) */
+#endif /* (BOARD_MPU6050_CONNECTED == true) */
 
 /** @} */
 
@@ -126,32 +125,35 @@ extern ROMCONST char* moduleShellPrompt;
 }
 
 /**
- * @brief   Unit test initialization hook.
+ * @brief   Test initialization hook.
  */
 #define MODULE_INIT_TESTS() {                                                 \
-  /* add unit-test shell commands */                                          \
+  /* initialize tests and add to shell */                                     \
+  aosShellAddCommand(&aos.shell, &moduleTestLedShellCmd);                     \
+  aosShellAddCommand(&aos.shell, &moduleTestButtonShellCmd);                  \
   MODULE_INIT_TEST_MPU6050();                                                 \
+  aosShellAddCommand(&aos.shell, &moduleTestAllShellCmd);                     \
 }
-#if defined(AMIROLLD_CFG_MPU6050)
+#if (BOARD_MPU6050_CONNECTED == true)
   #define MODULE_INIT_TEST_MPU6050() {                                        \
     /* add unit-test shell commands */                                        \
-    aosShellAddCommand(&aos.shell, &moduleUtAlldMpu6050.shellcmd);            \
+    aosShellAddCommand(&aos.shell, &moduleTestMpu6050ShellCmd);               \
   }
-#else /* defined(AMIROLLD_CFG_MPU6050) */
+#else /* (BOARD_MPU6050_CONNECTED == true) */
   #define MODULE_INIT_TEST_MPU6050() {}
-#endif /* defined(AMIROLLD_CFG_MPU6050) */
+#endif /* (BOARD_MPU6050_CONNECTED == true) */
 
 /**
  * @brief   Periphery communication interfaces initialization hook.
  */
-#define MODULE_INIT_PERIPHERY_COMM() {                                        \
+#define MODULE_INIT_PERIPHERY_IF() {                                          \
   /* serial driver */                                                         \
   sdStart(&MODULE_HAL_PROGIF, &moduleHalProgIfConfig);                        \
   /* MPU6050 demo */                                                          \
-  MODULE_INIT_PERIPHERY_COMM_MPU6050();                                       \
+  MODULE_INIT_PERIPHERY_IF_MPU6050();                                         \
 }
-#if defined(AMIROLLD_CFG_MPU6050)
-  #define MODULE_INIT_PERIPHERY_COMM_MPU6050() {                              \
+#if (BOARD_MPU6050_CONNECTED == true)
+  #define MODULE_INIT_PERIPHERY_IF_MPU6050() {                                \
     /* maximum I2C frequency is 1MHz for this MCU */                          \
     uint32_t i2c3_freq = 1000000;                                             \
     /* find minimum amon all devices connected to this bus */                 \
@@ -170,19 +172,19 @@ extern ROMCONST char* moduleShellPrompt;
     moduleHalI2c3Config.timingr |= ((((moduleHalI2c3Config.timingr & I2C_TIMINGR_SDADEL_Msk) >> I2C_TIMINGR_SDADEL_Pos) * 2) + 1) << I2C_TIMINGR_SCLDEL_Pos;  \
     /* now we can start the I2C driver */                                     \
     chSysLock();                                                              \
-    palSetLineMode(LINE_ARD_A4, PAL_MODE_ALTERNATE(4));                \
-    palSetLineMode(LINE_ARD_A5, PAL_MODE_ALTERNATE(4));                \
+    palSetLineMode(LINE_ARD_A4, PAL_MODE_ALTERNATE(4));                       \
+    palSetLineMode(LINE_ARD_A5, PAL_MODE_ALTERNATE(4));                       \
     chSysUnlock();                                                            \
     i2cStart(&MODULE_HAL_I2C3, &moduleHalI2c3Config);                         \
   }
-#else /* defined(AMIROLLD_CFG_MPU6050) */
-  #define MODULE_INIT_PERIPHERY_COMM_MPU6050() {}
-#endif /* defined(AMIROLLD_CFG_MPU6050) */
+#else /* (BOARD_MPU6050_CONNECTED == true) */
+  #define MODULE_INIT_PERIPHERY_IF_MPU6050() {}
+#endif /* (BOARD_MPU6050_CONNECTED == true) */
 
 /**
  * @brief   Periphery communication interface deinitialization hook.
  */
-#define MODULE_SHUTDOWN_PERIPHERY_COMM() {                                    \
+#define MODULE_SHUTDOWN_PERIPHERY_IF() {                                      \
 }
 
 /**
@@ -190,9 +192,9 @@ extern ROMCONST char* moduleShellPrompt;
  */
 #define MODULE_MAIN_LOOP_IO_EVENT(eventflags) {                               \
   if (eventflags & MODULE_OS_IOEVENTFLAGS_USERBUTTON) {                       \
-    apalControlGpioState_t buttonstate;                                       \
-    apalControlGpioGet(&moduleGpioUserButton, &buttonstate);                  \
-    apalControlGpioSet(&moduleGpioLed, buttonstate);                          \
+    button_lld_state_t buttonstate;                                           \
+    button_lld_get(&moduleLldUserButton, &buttonstate);                       \
+    led_lld_set(&moduleLldLed, (buttonstate == BUTTON_LLD_STATE_PRESSED) ? LED_LLD_STATE_ON : LED_LLD_STATE_OFF); \
   }                                                                           \
 }
 
@@ -213,8 +215,20 @@ extern ROMCONST char* moduleShellPrompt;
  * @{
  */
 /*===========================================================================*/
+#include <alld_LED.h>
+#include <alld_button.h>
 
-#if defined(AMIROLLD_CFG_MPU6050)
+/**
+ * @brief   LED driver.
+ */
+extern LEDDriver moduleLldLed;
+
+/**
+ * @brief   Button driver.
+ */
+extern ButtonDriver moduleLldUserButton;
+
+#if (BOARD_MPU6050_CONNECTED == true) || defined(__DOXYGEN__)
 
 #include <alld_MPU6050.h>
 
@@ -223,28 +237,41 @@ extern ROMCONST char* moduleShellPrompt;
  */
 extern MPU6050Driver moduleLldMpu6050;
 
-#endif /* defined(AMIROLLD_CFG_MPU6050) */
+#endif /* (BOARD_MPU6050_CONNECTED == true) */
 
 /** @} */
 
 /*===========================================================================*/
 /**
- * @name Unit tests (UT)
+ * @name Tests
  * @{
  */
 /*===========================================================================*/
 #if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
 
-#if defined(AMIROLLD_CFG_MPU6050)
+/**
+ * @brief   LED test command.
+ */
+extern aos_shellcommand_t moduleTestLedShellCmd;
+
+/**
+ * @brief   User button test command.
+ */
+extern aos_shellcommand_t moduleTestButtonShellCmd;
 
-#include <ut_alld_MPU6050_v1.h>
+#if (BOARD_MPU6050_CONNECTED == true) || defined(__DOXYGEN__)
 
 /**
- * @brief   MPU6050 unit test object.
+ * @brief   MPU6050 (Accelerometer & Gyroscope) test command.
  */
-extern aos_unittest_t moduleUtAlldMpu6050;
+extern aos_shellcommand_t moduleTestMpu6050ShellCmd;
 
-#endif /* defined(AMIROLLD_CFG_MPU6050) */
+#endif /* (BOARD_MPU6050_CONNECTED == true) */
+
+/**
+ * @brief   Entire module test command.
+ */
+extern aos_shellcommand_t moduleTestAllShellCmd;
 
 #endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
 
diff --git a/modules/NUCLEO-L476RG/test/LED/module_test_LED.c b/modules/NUCLEO-L476RG/test/LED/module_test_LED.c
new file mode 100644
index 0000000..96c8a1b
--- /dev/null
+++ b/modules/NUCLEO-L476RG/test/LED/module_test_LED.c
@@ -0,0 +1,70 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <module_test_LED.h>
+#include <aos_test_LED.h>
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+static aos_test_leddata_t _data = {
+  /* LED  */ &moduleLldLed,
+};
+
+static AOS_TEST(_test, "LED", NULL, moduleTestLedShellCb, aosTestLedFunc, &_data);
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+int moduleTestLedShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result)
+{
+  (void)argc;
+  (void)argv;
+
+  if (result != NULL) {
+    *result = aosTestRun(stream, &_test, NULL);
+  } else {
+    aosTestRun(stream, &_test, NULL);
+  }
+
+  return AOS_OK;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
diff --git a/modules/NUCLEO-L476RG/test/LED/module_test_LED.h b/modules/NUCLEO-L476RG/test/LED/module_test_LED.h
new file mode 100644
index 0000000..f9ae6c5
--- /dev/null
+++ b/modules/NUCLEO-L476RG/test/LED/module_test_LED.h
@@ -0,0 +1,66 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+
+#ifndef MODULE_TEST_LED_H
+#define MODULE_TEST_LED_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  int moduleTestLedShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* MODULE_TEST_LED_H */
+
diff --git a/modules/NUCLEO-L476RG/test/MPU6050/module_test_MPU6050.c b/modules/NUCLEO-L476RG/test/MPU6050/module_test_MPU6050.c
new file mode 100644
index 0000000..a5fac39
--- /dev/null
+++ b/modules/NUCLEO-L476RG/test/MPU6050/module_test_MPU6050.c
@@ -0,0 +1,71 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+
+#if ((AMIROOS_CFG_TESTS_ENABLE == true) && (BOARD_MPU6050_CONNECTED == true)) || defined(__DOXYGEN__)
+
+#include <module_test_MPU6050.h>
+#include <aos_test_MPU6050.h>
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+static aos_test_mpu6050data_t _data = {
+  /* driver   */ &moduleLldMpu6050,
+  /* timeout  */ MICROSECONDS_PER_SECOND,
+};
+
+static AOS_TEST(_test, "MPU6050", "Accelerometer & Gyroscope", moduleTestMpu6050ShellCb, aosTestMpu6050Func, &_data);
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+int moduleTestMpu6050ShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result)
+{
+  (void)argc;
+  (void)argv;
+
+  if (result != NULL) {
+    *result = aosTestRun(stream, &_test, NULL);
+  } else {
+    aosTestRun(stream, &_test, NULL);
+  }
+
+  return AOS_OK;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) && (BOARD_MPU6050_CONNECTED == true) */
diff --git a/modules/NUCLEO-L476RG/test/MPU6050/module_test_MPU6050.h b/modules/NUCLEO-L476RG/test/MPU6050/module_test_MPU6050.h
new file mode 100644
index 0000000..828e485
--- /dev/null
+++ b/modules/NUCLEO-L476RG/test/MPU6050/module_test_MPU6050.h
@@ -0,0 +1,66 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+
+#ifndef MODULE_TEST_MPU5040_H
+#define MODULE_TEST_MPU5040_H
+
+#include <amiroos.h>
+
+#if ((AMIROOS_CFG_TESTS_ENABLE == true) && (BOARD_MPU6050_CONNECTED == true)) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  int moduleTestMpu6050ShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) && (BOARD_MPU6050_CONNECTED == true) */
+
+#endif /* MODULE_TEST_MPU5040_H */
+
diff --git a/modules/NUCLEO-L476RG/test/button/module_test_button.c b/modules/NUCLEO-L476RG/test/button/module_test_button.c
new file mode 100644
index 0000000..9990b53
--- /dev/null
+++ b/modules/NUCLEO-L476RG/test/button/module_test_button.c
@@ -0,0 +1,72 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+#include <module_test_button.h>
+#include <aos_test_button.h>
+
+/******************************************************************************/
+/* LOCAL DEFINITIONS                                                          */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED VARIABLES                                                         */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL TYPES                                                                */
+/******************************************************************************/
+
+/******************************************************************************/
+/* LOCAL VARIABLES                                                            */
+/******************************************************************************/
+
+static aos_test_buttondata_t _data = {
+  /* button       */ &moduleLldUserButton,
+  /* event source */ &aos.events.io,
+  /* event flags  */ MODULE_OS_IOEVENTFLAGS_USERBUTTON,
+};
+
+static AOS_TEST(_test, "button", NULL, moduleTestButtonShellCb, aosTestButtonFunc, &_data);
+
+/******************************************************************************/
+/* LOCAL FUNCTIONS                                                            */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXPORTED FUNCTIONS                                                         */
+/******************************************************************************/
+
+int moduleTestButtonShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result)
+{
+  (void)argc;
+  (void)argv;
+
+  if (result != NULL) {
+    *result = aosTestRun(stream, &_test, NULL);
+  } else {
+    aosTestRun(stream, &_test, NULL);
+  }
+
+  return AOS_OK;
+}
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
diff --git a/modules/NUCLEO-L476RG/test/button/module_test_button.h b/modules/NUCLEO-L476RG/test/button/module_test_button.h
new file mode 100644
index 0000000..d7ebc43
--- /dev/null
+++ b/modules/NUCLEO-L476RG/test/button/module_test_button.h
@@ -0,0 +1,66 @@
+/*
+AMiRo-OS is an operating system designed for the Autonomous Mini Robot (AMiRo) platform.
+Copyright (C) 2016..2019  Thomas Schöpping et al.
+
+This program is free software: you can redistribute it and/or modify
+it under the terms of the GNU General Public License as published by
+the Free Software Foundation, either version 3 of the License, or
+(at your option) any later version.
+
+This program is distributed in the hope that it will be useful,
+but WITHOUT ANY WARRANTY; without even the implied warranty of
+MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+GNU General Public License for more details.
+
+You should have received a copy of the GNU General Public License
+along with this program.  If not, see <http://www.gnu.org/licenses/>.
+*/
+
+
+#ifndef MODULE_TEST_BUTTON_H
+#define MODULE_TEST_BUTTON_H
+
+#include <amiroos.h>
+
+#if (AMIROOS_CFG_TESTS_ENABLE == true) || defined(__DOXYGEN__)
+
+/******************************************************************************/
+/* CONSTANTS                                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* SETTINGS                                                                   */
+/******************************************************************************/
+
+/******************************************************************************/
+/* CHECKS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* DATA STRUCTURES AND TYPES                                                  */
+/******************************************************************************/
+
+/******************************************************************************/
+/* MACROS                                                                     */
+/******************************************************************************/
+
+/******************************************************************************/
+/* EXTERN DECLARATIONS                                                        */
+/******************************************************************************/
+
+#if defined(__cplusplus)
+extern "C" {
+#endif /* defined(__cplusplus) */
+  int moduleTestButtonShellCb(BaseSequentialStream* stream, int argc, char* argv[], aos_testresult_t* result);
+#if defined(__cplusplus)
+}
+#endif /* defined(__cplusplus) */
+
+/******************************************************************************/
+/* INLINE FUNCTIONS                                                           */
+/******************************************************************************/
+
+#endif /* (AMIROOS_CFG_TESTS_ENABLE == true) */
+
+#endif /* MODULE_TEST_BUTTON_H */
+
